Index: dev/rnd.c
===================================================================
RCS file: /cvsroot/src/sys/dev/rnd.c,v
retrieving revision 1.82
diff -u -b -r1.82 rnd.c
--- dev/rnd.c	11 Oct 2011 23:55:30 -0000	1.82
+++ dev/rnd.c	31 Oct 2011 04:29:14 -0000
@@ -50,6 +50,7 @@
 #include <sys/pool.h>
 #include <sys/kauth.h>
 #include <sys/once.h>
+#include <sys/rngtest.h>
 
 #if defined(__HAVE_CPU_COUNTER) && !defined(_RUMPKERNEL) /* XXX: bad pooka */
 #include <machine/cpu_counter.h>
@@ -89,7 +90,7 @@
 #define	RND_SAMPLE_COUNT	64	/* collect N samples, then compress */
 typedef struct _rnd_sample_t {
 	SIMPLEQ_ENTRY(_rnd_sample_t) next;
-	rndsource_t	*source;
+	krndsource_t	*source;
 	int		cursor;
 	int		entropy;
 	u_int32_t	ts[RND_SAMPLE_COUNT];
@@ -105,6 +106,13 @@
 kmutex_t			rnd_mtx;
 
 /*
+ * Entropy sinks: usually other generators waiting to be rekeyed.
+ * The list is protected by the rndpool_mtx.  A sink's callback MUST
+ * NOT re-add the sink to the list, or list corruption will occur.
+ */
+TAILQ_HEAD(, rndsink)		rnd_sinks;
+
+/*
  * our select/poll queue
  */
 struct selinfo rnd_selq;
@@ -130,12 +138,18 @@
  * This source is used to easily "remove" queue entries when the source
  * which actually generated the events is going away.
  */
-static rndsource_t rnd_source_no_collect = {
-	{ 'N', 'o', 'C', 'o', 'l', 'l', 'e', 'c', 't', 0, 0, 0, 0, 0, 0, 0 },
-	0, 0, 0, 0,
-	RND_TYPE_UNKNOWN,
-	(RND_FLAG_NO_COLLECT | RND_FLAG_NO_ESTIMATE | RND_TYPE_UNKNOWN),
-	NULL
+static krndsource_t rnd_source_no_collect = {
+	/* LIST_ENTRY list */
+	.name = { 'N', 'o', 'C', 'o', 'l', 'l', 'e', 'c', 't',
+		   0, 0, 0, 0, 0, 0, 0 },
+	.last_time = 0, .last_delta = 0, .last_delta2 = 0, .total = 0,
+	.type = RND_TYPE_UNKNOWN,
+	.flags = (RND_FLAG_NO_COLLECT |
+		  RND_FLAG_NO_ESTIMATE |
+		  RND_TYPE_UNKNOWN),
+	.state = NULL,
+	.test_cnt = 0,
+	.test = NULL
 };
 
 struct callout rnd_callout;
@@ -155,15 +169,17 @@
 };
 
 static inline void	rnd_wakeup_readers(void);
-static inline u_int32_t rnd_estimate_entropy(rndsource_t *, u_int32_t);
+static inline u_int32_t rnd_estimate_entropy(krndsource_t *, u_int32_t);
 static inline u_int32_t rnd_counter(void);
 static        void	rnd_timeout(void *);
+static	      void	rnd_process_events(void *);
 static u_int32_t	rnd_extract_data_locked(void *, u_int32_t, u_int32_t);
 
 static int		rnd_ready = 0;
 static int		rnd_have_entropy = 0;
+static int		rnd_tested = 0;
 
-LIST_HEAD(, __rndsource_element)	rnd_sources;
+LIST_HEAD(, krndsource)	rnd_sources;
 
 /*
  * Generate a 32-bit counter.  This should be more machine dependent,
@@ -192,12 +208,37 @@
 static inline void
 rnd_wakeup_readers(void)
 {
+	rndsink_t *sink, *tsink;
+	TAILQ_HEAD(, rndsink) sunk = TAILQ_HEAD_INITIALIZER(sunk);
+
+	mutex_enter(&rndpool_mtx);
+	if (rndpool_get_entropy_count(&rnd_pool) < RND_ENTROPY_THRESHOLD * 8) {
+		mutex_exit(&rndpool_mtx);
+		return;
+	}
 
 	/*
-	 * If we have added new bits, and now have enough to do something,
-	 * wake up sleeping readers.
+	 * First, take care of in-kernel consumers needing rekeying.
+	 */
+	TAILQ_FOREACH_SAFE(sink, &rnd_sinks, tailq, tsink) {
+		if ((sink->len + RND_ENTROPY_THRESHOLD) * 8 <
+			rndpool_get_entropy_count(&rnd_pool)) {
+			/* We have enough entropy to sink some here. */
+			if (rndpool_extract_data(&rnd_pool, sink->data,
+						 sink->len, RND_EXTRACT_GOOD)
+			    != sink->len) {
+				panic("could not extract estimated "
+				      "entropy from pool");
+			}
+			/* Move this sink to the list of pending callbacks */
+			TAILQ_REMOVE(&rnd_sinks, sink, tailq);
+			TAILQ_INSERT_HEAD(&sunk, sink, tailq);
+		}
+	}
+		
+	/*
+	 * If we still have enough new bits to do something, feed userspace.
 	 */
-	mutex_enter(&rndpool_mtx);
 	if (rndpool_get_entropy_count(&rnd_pool) > RND_ENTROPY_THRESHOLD * 8) {
 		cv_broadcast(&rndpool_cv);
 		selnotify(&rnd_selq, 0, 0);
@@ -210,6 +251,23 @@
 		rnd_have_entropy = 1;
 	}
 	mutex_exit(&rndpool_mtx);
+
+	/*
+	 * Now that we have dropped the mutex, we can run sinks' callbacks.
+	 * Since we have reused the "tailq" member of the sink structure for
+	 * this temporary on-stack queue, the callback must NEVER re-add
+	 * the sink to the main queue, or our on-stack queue will become
+	 * corrupt.
+	 */
+	while ((sink = TAILQ_FIRST(&sunk))) {
+#ifdef RND_VERBOSE
+		printf("supplying %d bytes to entropy sink \"%s\""
+		       " (cb %p, arg %p).\n",
+		       (int)sink->len, sink->name, sink->cb, sink->arg);
+#endif
+		sink->cb(sink->arg);
+		TAILQ_REMOVE(&sunk, sink, tailq);
+	}
 }
 
 /*
@@ -218,7 +276,7 @@
  * non-zero.  If any of these are zero, return zero.
  */
 static inline u_int32_t
-rnd_estimate_entropy(rndsource_t *rs, u_int32_t t)
+rnd_estimate_entropy(krndsource_t *rs, u_int32_t t)
 {
 	int32_t delta, delta2, delta3;
 
@@ -287,7 +345,9 @@
 
 	/* mix in another counter */
 	c = rnd_counter();
+	mutex_enter(&rndpool_mtx);
 	rndpool_add_data(&rnd_pool, &c, sizeof(u_int32_t), 1);
+	mutex_exit(&rndpool_mtx);
 }
 
 /*
@@ -315,6 +375,7 @@
 
 	LIST_INIT(&rnd_sources);
 	SIMPLEQ_INIT(&rnd_samples);
+	TAILQ_INIT(&rnd_sinks);
 	selinit(&rnd_selq);
 
 	rndpool_init(&rnd_pool);
@@ -327,9 +388,11 @@
 	 * XXX more things to add would be nice.
 	 */
 	if (c) {
+		mutex_enter(&rndpool_mtx);
 		rndpool_add_data(&rnd_pool, &c, sizeof(u_int32_t), 1);
 		c = rnd_counter();
 		rndpool_add_data(&rnd_pool, &c, sizeof(u_int32_t), 1);
+		mutex_exit(&rndpool_mtx);
 	}
 
 	rnd_ready = 1;
@@ -470,11 +533,21 @@
 	return (ret);
 }
 
+static void
+krndsource_to_rndsource(krndsource_t *kr, rndsource_t *r)
+{
+	memset(r, 0, sizeof(*r));
+	strlcpy(r->name, kr->name, sizeof(r->name));
+        r->total = kr->total;
+        r->type = kr->type;
+        r->flags = kr->flags;
+}
+
 int
 rndioctl(dev_t dev, u_long cmd, void *addr, int flag,
     struct lwp *l)
 {
-	rndsource_element_t *rse;
+	krndsource_t *kr;
 	rndstat_t *rst;
 	rndstat_name_t *rstnm;
 	rndctl_t *rctl;
@@ -552,10 +625,10 @@
 		 * Find the starting source by running through the
 		 * list of sources.
 		 */
-		rse = rnd_sources.lh_first;
+		kr = rnd_sources.lh_first;
 		start = rst->start;
-		while (rse != NULL && start >= 1) {
-			rse = rse->list.le_next;
+		while (kr != NULL && start >= 1) {
+			kr = kr->list.le_next;
 			start--;
 		}
 
@@ -564,15 +637,9 @@
 		 * for.  If we run out of sources, a count of zero
 		 * will be returned, without an error.
 		 */
-		for (count = 0; count < rst->count && rse != NULL; count++) {
-			memcpy(&rst->source[count], &rse->data,
-			    sizeof(rndsource_t));
-			/* Zero out information which may leak */
-			rst->source[count].last_time = 0;
-			rst->source[count].last_delta = 0;
-			rst->source[count].last_delta2 = 0;
-			rst->source[count].state = 0;
-			rse = rse->list.le_next;
+		for (count = 0; count < rst->count && kr != NULL; count++) {
+			krndsource_to_rndsource(kr, &rst->source[count]);
+			kr = kr->list.le_next;
 		}
 
 		rst->count = count;
@@ -584,15 +651,15 @@
 		 * Scan through the list, trying to find the name.
 		 */
 		rstnm = (rndstat_name_t *)addr;
-		rse = rnd_sources.lh_first;
-		while (rse != NULL) {
-			if (strncmp(rse->data.name, rstnm->name, 16) == 0) {
-				memcpy(&rstnm->source, &rse->data,
-				    sizeof(rndsource_t));
-
+		kr = rnd_sources.lh_first;
+		while (kr != NULL) {
+			if (strncmp(kr->name, rstnm->name,
+				    MIN(sizeof(kr->name),
+					sizeof(*rstnm))) == 0) {
+				krndsource_to_rndsource(kr, &rstnm->source);
 				return (0);
 			}
-			rse = rse->list.le_next;
+			kr = kr->list.le_next;
 		}
 
 		ret = ENOENT;		/* name not found */
@@ -605,19 +672,19 @@
 		 * collection.
 		 */
 		rctl = (rndctl_t *)addr;
-		rse = rnd_sources.lh_first;
+		kr = rnd_sources.lh_first;
 
 		/*
 		 * Flags set apply to all sources of this type.
 		 */
 		if (rctl->type != 0xff) {
-			while (rse != NULL) {
-				if (rse->data.type == rctl->type) {
-					rse->data.flags &= ~rctl->mask;
-					rse->data.flags |=
+			while (kr != NULL) {
+				if (kr->type == rctl->type) {
+					kr->flags &= ~rctl->mask;
+					kr->flags |=
 					    (rctl->flags & rctl->mask);
 				}
-				rse = rse->list.le_next;
+				kr = kr->list.le_next;
 			}
 
 			return (0);
@@ -626,14 +693,16 @@
 		/*
 		 * scan through the list, trying to find the name
 		 */
-		while (rse != NULL) {
-			if (strncmp(rse->data.name, rctl->name, 16) == 0) {
-				rse->data.flags &= ~rctl->mask;
-				rse->data.flags |= (rctl->flags & rctl->mask);
+		while (kr != NULL) {
+			if (strncmp(kr->name, rctl->name,
+				    MIN(sizeof(kr->name),
+                                        sizeof(rctl->name))) == 0) {
+				kr->flags &= ~rctl->mask;
+				kr->flags |= (rctl->flags & rctl->mask);
 
 				return (0);
 			}
-			rse = rse->list.le_next;
+			kr = kr->list.le_next;
 		}
 
 		ret = ENOENT;		/* name not found */
@@ -763,7 +832,7 @@
 }
 
 static rnd_sample_t *
-rnd_sample_allocate(rndsource_t *source)
+rnd_sample_allocate(krndsource_t *source)
 {
 	rnd_sample_t *c;
 
@@ -782,7 +851,7 @@
  * Don't wait on allocation.  To be used in an interrupt context.
  */
 static rnd_sample_t *
-rnd_sample_allocate_isr(rndsource_t *source)
+rnd_sample_allocate_isr(krndsource_t *source)
 {
 	rnd_sample_t *c;
 
@@ -800,7 +869,7 @@
 static void
 rnd_sample_free(rnd_sample_t *c)
 {
-	memset(c, 0, sizeof(rnd_sample_t));
+	memset(c, 0, sizeof(*c));
 	pool_put(&rnd_mempool, c);
 }
 
@@ -808,7 +877,7 @@
  * Add a source to our list of sources.
  */
 void
-rnd_attach_source(rndsource_element_t *rs, const char *name, u_int32_t type,
+rnd_attach_source(krndsource_t *rs, const char *name, u_int32_t type,
     u_int32_t flags)
 {
 	u_int32_t ts;
@@ -817,11 +886,11 @@
 
 	ts = rnd_counter();
 
-	strlcpy(rs->data.name, name, sizeof(rs->data.name));
-	rs->data.last_time = ts;
-	rs->data.last_delta = 0;
-	rs->data.last_delta2 = 0;
-	rs->data.total = 0;
+	strlcpy(rs->name, name, sizeof(rs->name));
+	rs->last_time = ts;
+	rs->last_delta = 0;
+	rs->last_delta2 = 0;
+	rs->total = 0;
 
 	/*
 	 * Force network devices to not collect any entropy by
@@ -830,15 +899,27 @@
 	if (type == RND_TYPE_NET)
 		flags |= (RND_FLAG_NO_COLLECT | RND_FLAG_NO_ESTIMATE);
 
-	rs->data.type = type;
-	rs->data.flags = flags;
+	/*
+ 	 * Hardware RNGs get extra space for statistical testing.
+	 */
+	if (type == RND_TYPE_RNG) {
+		rs->test = kmem_alloc(sizeof(rngtest_t), KM_NOSLEEP);
+		rs->test_cnt = 0;
+	} else {
+		rs->test = NULL;
+		rs->test_cnt = -1;
+	}
 
-	rs->data.state = rnd_sample_allocate(&rs->data);
+	rs->type = type;
+	rs->flags = flags;
 
+	rs->state = rnd_sample_allocate(rs);
+
+	mutex_enter(&rndpool_mtx);
 	LIST_INSERT_HEAD(&rnd_sources, rs, list);
 
 #ifdef RND_VERBOSE
-	printf("rnd: %s attached as an entropy source (", rs->data.name);
+	printf("rnd: %s attached as an entropy source (", rs->name);
 	if (!(flags & RND_FLAG_NO_COLLECT)) {
 		printf("collecting");
 		if (flags & RND_FLAG_NO_ESTIMATE)
@@ -854,28 +935,30 @@
 	 * XXX Bogus, but harder to guess than zeros.
 	 */
 	rndpool_add_data(&rnd_pool, &ts, sizeof(u_int32_t), 1);
+	mutex_exit(&rndpool_mtx);
 }
 
 /*
  * Remove a source from our list of sources.
  */
 void
-rnd_detach_source(rndsource_element_t *rs)
+rnd_detach_source(krndsource_t *source)
 {
 	rnd_sample_t *sample;
-	rndsource_t *source;
-
-	mutex_enter(&rnd_mtx);
 
-	LIST_REMOVE(rs, list);
+	mutex_spin_enter(&rnd_mtx);
 
-	source = &rs->data;
+	LIST_REMOVE(source, list);
 
 	if (source->state) {
 		rnd_sample_free(source->state);
 		source->state = NULL;
 	}
 
+	if (source->test) {
+		kmem_free(source->test, sizeof(rngtest_t));
+	}
+
 	/*
 	 * If there are samples queued up "remove" them from the sample queue
 	 * by setting the source to the no-collect pseudosource.
@@ -888,9 +971,9 @@
 		sample = SIMPLEQ_NEXT(sample, next);
 	}
 
-	mutex_exit(&rnd_mtx);
+	mutex_spin_exit(&rnd_mtx);
 #ifdef RND_VERBOSE
-	printf("rnd: %s detached as an entropy source\n", rs->data.name);
+	printf("rnd: %s detached as an entropy source\n", source->name);
 #endif
 }
 
@@ -899,16 +982,12 @@
  * source-specific source structure.
  */
 void
-rnd_add_uint32(rndsource_element_t *rs, u_int32_t val)
+rnd_add_uint32(krndsource_t *rs, u_int32_t val)
 {
-	rndsource_t *rst;
-	rnd_sample_t *state;
 	u_int32_t ts;
+	u_int32_t entropy = 0;
 
-
-	rst = &rs->data;
-
-	if (rst->flags & RND_FLAG_NO_COLLECT)
+	if (rs->flags & RND_FLAG_NO_COLLECT)
 		return;
 
 	/*
@@ -918,134 +997,263 @@
 	ts = rnd_counter();
 
 	/*
-	 * If the sample buffer is NULL, try to allocate one here.  If this
-	 * fails, drop this sample.
+	 * If we are estimating entropy on this source,
+	 * calculate differentials.
 	 */
-	state = rst->state;
-	if (state == NULL) {
-		state = rnd_sample_allocate_isr(rst);
-		if (state == NULL)
+
+	if ((rs->flags & RND_FLAG_NO_ESTIMATE) == 0) {
+		entropy = rnd_estimate_entropy(rs, ts);
+	}
+
+	rnd_add_data(rs, &val, sizeof(val), entropy);
+}
+
+void
+rnd_add_data(krndsource_t *rs, const void *const data, u_int32_t len,
+    u_int32_t entropy)
+{
+	rnd_sample_t *state = NULL;
+	uint32_t ts;
+	const uint32_t *dint = data;
+	int todo, done, filled = 0;
+	SIMPLEQ_HEAD(, _rnd_sample_t) tmp_samples =
+	    		SIMPLEQ_HEAD_INITIALIZER(tmp_samples);
+
+	if (rs->flags & RND_FLAG_NO_COLLECT) {
 			return;
-		rst->state = state;
 	}
 
 	/*
-	 * If we are estimating entropy on this source,
-	 * calculate differentials.
+         * Sample the counter as soon as possible to avoid entropy
+         * overestimation.
 	 */
+        ts = rnd_counter();
 
-	if ((rst->flags & RND_FLAG_NO_ESTIMATE) == 0)
-		state->entropy += rnd_estimate_entropy(rst, ts);
+	/*
+	 * Loop over data packaging it into sample buffers.
+	 * If a sample buffer allocation fails, drop all data.
+	 */
+	todo = len / sizeof(*dint);
+	for (done = 0; done < todo ; done++) {
+		state = rs->state;
+		if (state == NULL) {
+			state = rnd_sample_allocate_isr(rs);
+			if (__predict_false(state == NULL)) {
+				break;
+			}
+			rs->state = state;
+		}
 
 	state->ts[state->cursor] = ts;
-	state->values[state->cursor] = val;
+		state->values[state->cursor] = dint[done];
 	state->cursor++;
 
+		if (state->cursor == RND_SAMPLE_COUNT) {
+			SIMPLEQ_INSERT_HEAD(&tmp_samples, state, next);
+			filled++;
+			rs->state = NULL;
+		}
+	}
+
+	if (__predict_false(state == NULL)) {
+		while ((state = SIMPLEQ_FIRST(&tmp_samples))) {
+			SIMPLEQ_REMOVE_HEAD(&tmp_samples, next);
+			rnd_sample_free(state);
+		}
+		return;
+	}
+
 	/*
-	 * If the state arrays are not full, we're done.
+	 * Claim all the entropy on the last one we send to
+	 * the pool, so we don't rely on it being evenly distributed
+	 * in the supplied data.
+	 *
+	 * XXX The rndpool code must accept samples with more
+	 * XXX claimed entropy than bits for this to work right.
 	 */
-	if (state->cursor < RND_SAMPLE_COUNT)
-		return;
+	state->entropy += entropy;
+	rs->total += entropy;
 
 	/*
-	 * State arrays are full.  Queue this chunk on the processing queue.
+	 * If we didn't finish any sample buffers, we're done.
 	 */
-	mutex_enter(&rnd_mtx);
+	if (!filled) {
+		return;
+	}
+
+	mutex_spin_enter(&rnd_mtx);
+	while ((state = SIMPLEQ_FIRST(&tmp_samples))) {
+		SIMPLEQ_REMOVE_HEAD(&tmp_samples, next);
 	SIMPLEQ_INSERT_HEAD(&rnd_samples, state, next);
-	rst->state = NULL;
+	}
 
 	/*
-	 * If the timeout isn't pending, have it run in the near future.
+	 * If we are still starting up, cause immediate processing of
+	 * the queued samples.  Otherwise, if the timeout isn't
+	 * pending, have it run in the near future.
 	 */
+	if (__predict_false(cold)) {
+#ifdef RND_VERBOSE
+		printf("rnd: directly processing boot-time events.\n");
+#endif
+		rnd_process_events(NULL);	/* Drops lock! */
+		return;
+	} else {
 	if (rnd_timeout_pending == 0) {
 		rnd_timeout_pending = 1;
-		callout_reset(&rnd_callout, 1, rnd_timeout, NULL);
+			callout_reset(&rnd_callout, 1,
+				      rnd_timeout, NULL);
 	}
-	mutex_exit(&rnd_mtx);
-
-	/*
-	 * To get here we have to have queued the state up, and therefore
-	 * we need a new state buffer.  If we can, allocate one now;
-	 * if we don't get it, it doesn't matter; we'll try again on
-	 * the next random event.
-	 */
-	rst->state = rnd_sample_allocate_isr(rst);
+	}
+	mutex_spin_exit(&rnd_mtx);
 }
 
-void
-rnd_add_data(rndsource_element_t *rs, void *data, u_int32_t len,
-    u_int32_t entropy)
+static int
+rnd_hwrng_test(rnd_sample_t *sample)
 {
-	rndsource_t *rst;
+	krndsource_t *source = sample->source;
+	size_t cmplen;
+	uint8_t *v1, *v2;
+	size_t resid, totest;
 
-	/* Mix in the random data directly into the pool. */
-	rndpool_add_data(&rnd_pool, data, len, entropy);
+	KASSERT(source->type = RND_TYPE_RNG);
 
-	if (rs != NULL) {
-		rst = &rs->data;
-		rst->total += entropy;
+	/*
+	 * Continuous-output test: compare two halves of the
+	 * sample buffer to each other.  The sample buffer (64 ints,
+	 * so either 256 or 512 bytes on any modern machine) should be
+	 * much larger than a typical hardware RNG output, so this seems
+	 * a reasonable way to do it without retaining extra data.
+	 */
+	cmplen = sizeof(sample->values) / 2;
+	v1 = (uint8_t *)sample->values;
+	v2 = (uint8_t *)sample->values + cmplen;
 
-		if ((rst->flags & RND_FLAG_NO_ESTIMATE) == 0)
-			/* Estimate entropy using timing information */
-			rnd_add_uint32(rs, *(u_int8_t *)data);
+	if (__predict_false(memcmp(v1, v2, cmplen))) {
+		printf("rnd: source \"%s\" failed continuous-output test.",
+		       source->name);
+		return 1;
 	}
 
-	/* Wake up any potential readers since we've just added some data. */
-	rnd_wakeup_readers();
+	/*
+	 * FIPS 140 statistical RNG test.  We must accumulate 20,000 bits.
+	 */
+	if (__predict_true(source->test_cnt == -1)) {
+		/* already passed the test */
+		return 0;
+	}
+	resid = FIPS140_RNG_TEST_BYTES - source->test_cnt;
+	totest = MIN(RND_SAMPLE_COUNT * 4, resid);
+	memcpy(source->test->rt_b + source->test_cnt, sample->values, totest);
+	resid -= totest;
+	source->test_cnt += totest;
+	if (resid == 0) {
+		strlcpy(source->test->rt_name, source->name,
+			sizeof(source->test->rt_name));
+		if (rngtest(source->test)) {
+			printf("rnd: source \"%s\" failed statistical test.",
+			       source->name);
+			return 1;
+		}
+		source->test_cnt = -1;
+		memset(source->test, 0, sizeof(*source->test));
+	}
+	return 0;
 }
 
 /*
- * Timeout, run to process the events in the ring buffer. 
+ * Process the events in the ring buffer.  Called by rnd_timeout or
+ * by the add routines directly if the callout has never fired (that
+ * is, if we are "cold" -- just booted).
+ *
+ * Call with rnd_mtx held -- WILL RELEASE IT.
  */
 static void
-rnd_timeout(void *arg)
+rnd_process_events(void *arg)
 {
 	rnd_sample_t *sample;
-	rndsource_t *source;
+	krndsource_t *source, *badsource = NULL;
 	u_int32_t entropy;
+	SIMPLEQ_HEAD(, _rnd_sample_t) dq_samples =
+			SIMPLEQ_HEAD_INITIALIZER(dq_samples);
+	SIMPLEQ_HEAD(, _rnd_sample_t) df_samples =
+			SIMPLEQ_HEAD_INITIALIZER(df_samples);
 
 	/*
-	 * Sample queue is protected by rnd_mtx, take it briefly to dequeue.
+	 * Sample queue is protected by rnd_mtx, drain to onstack queue
+	 * and drop lock.
 	 */
-	mutex_enter(&rnd_mtx);
-	rnd_timeout_pending = 0;
 
-	sample = SIMPLEQ_FIRST(&rnd_samples);
-	while (sample != NULL) {
+	while ((sample = SIMPLEQ_FIRST(&rnd_samples))) {
 		SIMPLEQ_REMOVE_HEAD(&rnd_samples, next);
-		mutex_exit(&rnd_mtx);
-
-		source = sample->source;
-
 		/*
-		 * We repeat this check here, since it is possible the source
-		 * was disabled before we were called, but after the entry
-		 * was queued.
+		 * We repeat this check here, since it is possible
+		 * the source was disabled before we were called, but
+		 * after the entry was queued.
 		 */
-		if ((source->flags & RND_FLAG_NO_COLLECT) == 0) {
+		if (__predict_false(sample->source->flags
+				    & RND_FLAG_NO_COLLECT)) {
+			SIMPLEQ_INSERT_TAIL(&df_samples, sample, next);
+		} else {
+			SIMPLEQ_INSERT_TAIL(&dq_samples, sample, next);
+		}
+	}
+	mutex_spin_exit(&rnd_mtx);
+
+	/* Don't thrash the rndpool mtx either.  Hold, add all samples. */
+	mutex_enter(&rndpool_mtx);
+	while ((sample = SIMPLEQ_FIRST(&dq_samples))) {
+		SIMPLEQ_REMOVE_HEAD(&dq_samples, next);
+		source = sample->source;
 			entropy = sample->entropy;
 			if (source->flags & RND_FLAG_NO_ESTIMATE)
 				entropy = 0;
 
-			mutex_enter(&rndpool_mtx);
+		/*
+		 * Hardware generators are great but sometimes they
+		 * have...hardware issues.  Don't use any data from
+		 * them unless it passes some tests.
+		 */
+		if (source->type == RND_TYPE_RNG) {
+			if (__predict_false(rnd_hwrng_test(sample))) {
+				/*
+				 * Detach the bad source.  See below.
+				 */
+				badsource = source;
+				printf("rnd: detaching source \"%s\".",
+				       badsource->name);
+				break;
+			}
+		}
 			rndpool_add_data(&rnd_pool, sample->values,
 			    RND_SAMPLE_COUNT * 4, 0);
 
 			rndpool_add_data(&rnd_pool, sample->ts,
-			    RND_SAMPLE_COUNT * 4,
-			    entropy);
-			mutex_exit(&rndpool_mtx);
+		    RND_SAMPLE_COUNT * 4, entropy);
 
 			source->total += sample->entropy;
+		SIMPLEQ_INSERT_TAIL(&df_samples, sample, next);
 		}
+	mutex_exit(&rndpool_mtx);
 
+	/* Now we hold no locks: clean up. */
+	if (__predict_false(badsource)) {
+		/*
+		 * The detach routine frees any samples we have not
+		 * dequeued ourselves.  For sanity's sake, we simply
+		 * free (without using) all dequeued samples from the
+		 * point at which we detected a problem onwards.
+		 */
+		rnd_detach_source(badsource);
+		while ((sample = SIMPLEQ_FIRST(&dq_samples))) {
+			SIMPLEQ_REMOVE_HEAD(&dq_samples, next);
+			rnd_sample_free(sample);
+		}
+	}
+	while ((sample = SIMPLEQ_FIRST(&df_samples))) {
+		SIMPLEQ_REMOVE_HEAD(&df_samples, next);
 		rnd_sample_free(sample);
-
-		/* Get mtx back to dequeue the next one.. */
-		mutex_enter(&rnd_mtx);
-		sample = SIMPLEQ_FIRST(&rnd_samples);
 	}
-	mutex_exit(&rnd_mtx);
 
 	/*
 	 * Wake up any potential readers waiting.
@@ -1053,6 +1261,17 @@
 	rnd_wakeup_readers();
 }
 
+/*
+ * Timeout, run to process the events in the ring buffer.
+ */
+static void
+rnd_timeout(void *arg)
+{
+        mutex_spin_enter(&rnd_mtx);
+        rnd_timeout_pending = 0;
+        rnd_process_events(arg);
+}
+
 static u_int32_t
 rnd_extract_data_locked(void *p, u_int32_t len, u_int32_t flags)
 {
@@ -1069,6 +1288,42 @@
 		c = rnd_counter();
 		rndpool_add_data(&rnd_pool, &c, sizeof(u_int32_t), 1);
 	}
+	if (!rnd_tested) {
+		rngtest_t rt;
+		uint8_t testbits[sizeof(rt.rt_b)];
+		int entropy_count;
+
+		entropy_count = rndpool_get_entropy_count(&rnd_pool);
+#ifdef RND_VERBOSE
+		printf("rnd: starting statistical RNG test, entropy = %d.\n",
+			entropy_count);
+#endif
+		if (rndpool_extract_data(&rnd_pool, rt.rt_b,
+		    sizeof(rt.rt_b), RND_EXTRACT_ANY) != sizeof(rt.rt_b)) {
+			panic("rnd: could not get bits for statistical test");
+		}
+		/*
+		 * Stash the tested bits so we can put them back in the
+		 * pool, restoring the entropy count.  DO NOT rely on
+		 * rngtest to maintain the bits pristine -- we could end
+		 * up adding back non-random data claiming it were pure
+		 * entropy.
+		 */
+		memcpy(testbits, rt.rt_b, sizeof(rt.rt_b));
+		strlcpy(rt.rt_name, "entropy pool", sizeof(rt.rt_name));
+		if (rngtest(&rt)) {
+			panic("rnd: entropy pool failed statistical test");
+		}
+		memset(&rt, 0, sizeof(rt));
+		rndpool_add_data(&rnd_pool, testbits, sizeof(testbits),
+				 entropy_count);
+		memset(testbits, 0, sizeof(testbits));
+#ifdef RND_VERBOSE
+		printf("rnd: statistical RNG test done, entropy = %d.\n",
+		       rndpool_get_entropy_count(&rnd_pool));
+#endif
+		rnd_tested++;
+	}
 	return rndpool_extract_data(&rnd_pool, p, len, flags);
 }
 
@@ -1082,3 +1337,26 @@
 	mutex_exit(&rndpool_mtx);
 	return retval;
 }
+
+void
+rndsink_attach(rndsink_t *rs)
+{
+#ifdef RND_VERBOSE
+	printf("rnd: entropy sink \"%s\" wants %d bytes of data.\n",
+	       rs->name, (int)rs->len);
+#endif
+	mutex_enter(&rndpool_mtx);
+	TAILQ_INSERT_TAIL(&rnd_sinks, rs, tailq);
+	mutex_exit(&rndpool_mtx);
+}
+
+void
+rndsink_detach(rndsink_t *rs)
+{
+#ifdef RND_VERBOSE
+	printf("rnd: entropy sink \"%s\" no longer wants data.\n", rs->name);
+#endif
+	mutex_enter(&rndpool_mtx);
+	TAILQ_REMOVE(&rnd_sinks, rs, tailq);
+	mutex_exit(&rndpool_mtx);
+}
Index: dev/ata/wdvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ata/wdvar.h,v
retrieving revision 1.38
diff -u -b -r1.38 wdvar.h
--- dev/ata/wdvar.h	17 Dec 2009 21:03:10 -0000	1.38
+++ dev/ata/wdvar.h	31 Oct 2011 04:29:14 -0000
@@ -67,7 +67,7 @@
 	u_int sc_bscount;
 #endif
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: dev/gpib/rd.c
===================================================================
RCS file: /cvsroot/src/sys/dev/gpib/rd.c,v
retrieving revision 1.28
diff -u -b -r1.28 rd.c
--- dev/gpib/rd.c	8 Feb 2011 20:20:27 -0000	1.28
+++ dev/gpib/rd.c	31 Oct 2011 04:29:14 -0000
@@ -143,7 +143,7 @@
 	struct	callout sc_restart_ch;
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: dev/ic/comvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/comvar.h,v
retrieving revision 1.71
diff -u -b -r1.71 comvar.h
--- dev/ic/comvar.h	13 Nov 2010 15:35:50 -0000	1.71
+++ dev/ic/comvar.h	31 Oct 2011 04:29:14 -0000
@@ -228,7 +228,7 @@
 	struct pps_state sc_pps_state;	/* pps state */
 
 #if NRND > 0 && defined(RND_COM)
-	rndsource_element_t  rnd_source;
+	krndsource_t  rnd_source;
 #endif
 	kmutex_t		sc_lock;
 };
Index: dev/ic/cs89x0var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/cs89x0var.h,v
retrieving revision 1.14
diff -u -b -r1.14 cs89x0var.h
--- dev/ic/cs89x0var.h	22 Sep 2009 14:55:19 -0000	1.14
+++ dev/ic/cs89x0var.h	31 Oct 2011 04:29:14 -0000
@@ -105,7 +105,7 @@
 	u_int16_t *eeprom_data;		/* copy of the eeprom data */
 
 #if NRND > 0
-	rndsource_element_t rnd_source; /* random source */
+	krndsource_t rnd_source; /* random source */
 #endif
 
 	/* power management */
Index: dev/ic/dp8390var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/dp8390var.h,v
retrieving revision 1.30
diff -u -b -r1.30 dp8390var.h
--- dev/ic/dp8390var.h	12 May 2009 14:25:17 -0000	1.30
+++ dev/ic/dp8390var.h	31 Oct 2011 04:29:14 -0000
@@ -72,7 +72,7 @@
 	int	sc_enabled;	/* boolean; power enabled on interface */
 
 #if NRND > 0
-	rndsource_element_t rnd_source; /* random source */
+	krndsource_t rnd_source; /* random source */
 #endif
 
 	int	(*test_mem)(struct dp8390_softc *);
Index: dev/ic/elink3var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/elink3var.h,v
retrieving revision 1.36
diff -u -b -r1.36 elink3var.h
--- dev/ic/elink3var.h	5 Sep 2009 12:30:59 -0000	1.36
+++ dev/ic/elink3var.h	31 Oct 2011 04:29:14 -0000
@@ -102,7 +102,7 @@
 	int ep_pktlenshift;		/* scale factor for pkt lengths */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 
 	/* power management hooks */
Index: dev/ic/elinkxlvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/elinkxlvar.h,v
retrieving revision 1.22
diff -u -b -r1.22 elinkxlvar.h
--- dev/ic/elinkxlvar.h	22 Mar 2010 23:03:30 -0000	1.22
+++ dev/ic/elinkxlvar.h	31 Oct 2011 04:29:14 -0000
@@ -110,7 +110,7 @@
 #define EX_FLAGS_ATTACHED		0x4000	/* attach has succeeded */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 
 	/* power management hooks */
Index: dev/ic/gemvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/gemvar.h,v
retrieving revision 1.21
diff -u -b -r1.21 gemvar.h
--- dev/ic/gemvar.h	24 Feb 2010 22:37:58 -0000	1.21
+++ dev/ic/gemvar.h	31 Oct 2011 04:29:14 -0000
@@ -217,7 +217,7 @@
 	void	(*sc_hwinit)(struct gem_softc *);
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 
 	struct evcnt sc_ev_intr;
Index: dev/ic/hmevar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/hmevar.h,v
retrieving revision 1.21
diff -u -b -r1.21 hmevar.h
--- dev/ic/hmevar.h	18 Sep 2009 12:40:15 -0000	1.21
+++ dev/ic/hmevar.h	31 Oct 2011 04:29:14 -0000
@@ -95,7 +95,7 @@
 	void	(*sc_hwinit)(struct hme_softc *);
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: dev/ic/i82557var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/i82557var.h,v
retrieving revision 1.48
diff -u -b -r1.48 i82557var.h
--- dev/ic/i82557var.h	25 Feb 2010 23:40:39 -0000	1.48
+++ dev/ic/i82557var.h	31 Oct 2011 04:29:14 -0000
@@ -242,7 +242,7 @@
 
 	int	sc_eeprom_size;		/* log2 size of EEPROM */
 #if NRND > 0
-	rndsource_element_t rnd_source;	/* random source */
+	krndsource_t rnd_source;	/* random source */
 #endif
 
 };
Index: dev/ic/lan9118var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/lan9118var.h,v
retrieving revision 1.2
diff -u -b -r1.2 lan9118var.h
--- dev/ic/lan9118var.h	28 Nov 2009 08:44:00 -0000	1.2
+++ dev/ic/lan9118var.h	31 Oct 2011 04:29:14 -0000
@@ -76,7 +76,7 @@
 #define LAN9118_FLAGS_NO_EEPROM	0x00000002
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: dev/ic/lancevar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/lancevar.h,v
retrieving revision 1.13
diff -u -b -r1.13 lancevar.h
--- dev/ic/lancevar.h	4 Sep 2009 16:21:24 -0000	1.13
+++ dev/ic/lancevar.h	31 Oct 2011 04:29:14 -0000
@@ -116,7 +116,7 @@
 	uint8_t sc_enaddr[ETHER_ADDR_LEN];
 	uint8_t sc_pad[2];
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 
 	void (*sc_meminit)(struct lance_softc *);
Index: dev/ic/lemacvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/lemacvar.h,v
retrieving revision 1.9
diff -u -b -r1.9 lemacvar.h
--- dev/ic/lemacvar.h	11 Dec 2005 12:21:27 -0000	1.9
+++ dev/ic/lemacvar.h	31 Oct 2011 04:29:14 -0000
@@ -80,7 +80,7 @@
     char sc_prodname[LEMAC_EEP_PRDNMSZ+1]; /* product name DE20x-xx */
     u_int8_t sc_eeprom[LEMAC_EEP_SIZE];	/* local copy eeprom */
 #if NRND > 0
-    rndsource_element_t rnd_source;
+    krndsource_t rnd_source;
 #endif
 } lemac_softc_t;
 
Index: dev/ic/mb86950var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/mb86950var.h,v
retrieving revision 1.5
diff -u -b -r1.5 mb86950var.h
--- dev/ic/mb86950var.h	12 May 2009 14:25:17 -0000	1.5
+++ dev/ic/mb86950var.h	31 Oct 2011 04:29:14 -0000
@@ -60,7 +60,7 @@
 	u_int8_t sc_enaddr[ETHER_ADDR_LEN];
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 
 	u_int32_t sc_stat;	/* driver status */
Index: dev/ic/mb86960var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/mb86960var.h,v
retrieving revision 1.37
diff -u -b -r1.37 mb86960var.h
--- dev/ic/mb86960var.h	12 May 2009 14:25:17 -0000	1.37
+++ dev/ic/mb86960var.h	31 Oct 2011 04:29:14 -0000
@@ -162,7 +162,7 @@
 	uint8_t sc_enaddr[ETHER_ADDR_LEN];
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 
 	uint32_t sc_stat;	/* driver status */
Index: dev/ic/mtd803var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/mtd803var.h,v
retrieving revision 1.6
diff -u -b -r1.6 mtd803var.h
--- dev/ic/mtd803var.h	28 Apr 2008 20:23:50 -0000	1.6
+++ dev/ic/mtd803var.h	31 Oct 2011 04:29:14 -0000
@@ -75,7 +75,7 @@
 	bus_dmamap_t		buf_dma_map;
 
 #if NRND > 0
-	rndsource_element_t	rnd_src;
+	krndsource_t	rnd_src;
 #endif
 };
 
